/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of NewmanGirvan.xs. Do not edit this file, edit NewmanGirvan.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "NewmanGirvan.xs"
// Quick and very dirty port of of the clustering algorithm implementation
// from Andreas Noack's <http://code.google.com/p/linloglayout/> released
// under the terms of the LGPLv2.1+.

#include <list>
#include <map>
#include <istream>
#include <ostream>
#include <string>
#include <algorithm>
#include <iostream>
#include <sstream>
#include <fstream>
#include <vector>
#include <limits>

extern "C"
{
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
}

#undef max

class node {
public:
  node() : name(-1), weight(0) {
  }
  node(long aName, double aWeight) : weight(aWeight), name(aName) {
  }
  node(std::map< std::string, long>& string_map, std::string aName, double aWeight)
    : weight(aWeight) {
    if (string_map.find(aName) != string_map.end()) {
      name = string_map.find(aName)->second;
    } else {
      name = string_map.size();
      string_map.insert(std::pair<std::string, long>(aName, name));
    }
  }
  long name;
  double weight;
  int operator==(const node& right) const {
    return name == right.name;
  }
  bool operator<(const node& right) const {
    return name < right.name;
  }
};

class edge {
public:
  edge(node aSrc, node aDst, double aWeight)
    : src(aSrc), dst(aDst), weight(aWeight) {
  }
  class node src;
  class node dst;
  double weight;
  int operator==(const edge& right) const {
    return src == right.src && dst == right.dst && weight == right.weight;
  }
};

class NewmanGirvan {
public:
  std::map< std::string, long> string_map;
  std::map< std::string, node > nameToNode;
  std::map< long, double > nameToWeight;
  std::map< node, std::string > nodeToName;
  std::map< std::pair< node, node >, double> edgeToWeight;
  std::map< std::pair< node, node >, double>::iterator edgeToWeight_iter;

  void add_edge(std::string src, std::string dst, double weight) {
    if (nameToNode.find(src) == nameToNode.end()) {
      node new_node = createNode(src, 0);
      nameToNode.insert(std::pair<std::string, node>(src, new_node));
      nodeToName.insert(std::pair<node, std::string>(new_node, src));
    }
    if (nameToNode.find(dst) == nameToNode.end()) {
      node new_node = createNode(dst, 0);
      nameToNode.insert(std::pair<std::string, node>(dst, new_node));
      nodeToName.insert(std::pair<node, std::string>(new_node, dst));
    }
    edgeToWeight.insert(std::pair< std::pair<node, node>, double>(
      std::pair<node, node>(nameToNode[src], nameToNode[dst]),
      weight
    ));
  }

  void set_vertex_weight(std::string vertex, double weight) {
    nameToWeight[ string_map[vertex] ] = weight;
  }

  std::map<std::string, int> run() {
    std::list< edge > edges;
    for (edgeToWeight_iter = edgeToWeight.begin(); edgeToWeight_iter != edgeToWeight.end(); ++edgeToWeight_iter) {
      node src = edgeToWeight_iter->first.first;
      node dst = edgeToWeight_iter->first.second;
      double weight = edgeToWeight_iter->second;
      double revWeight = 0;
      std::pair<node, node> rev = std::pair<node,node>(dst, src);
      if (edgeToWeight.find(rev) != edgeToWeight.end()) {
        revWeight = edgeToWeight[rev];
      } else {
        edges.push_back(createEdge(dst, src, weight + revWeight));
      }
      edges.push_back(createEdge(src, dst, weight + revWeight));
    }

    std::list<edge> edges2;
    for (std::list< edge >::iterator i = edges.begin(); i != edges.end(); ++i) {
      edges2.push_back(createEdge(createNode(i->src.name, nameToWeight[ i->src.name ]),
                                  createNode(i->dst.name, nameToWeight[ i->dst.name ]),
                            i->weight));
    }

    edges = edges2;

    std::list<node> nodes;

    for (std::map< std::string, node >::iterator i = nameToNode.begin(); i != nameToNode.end(); ++i) {
      nodes.push_back(createNode(i->second.name, nameToWeight[i->second.name]));
    }

    std::map<node, int> temp = execute(nodes, edges, false);
    std::map<std::string, int> result;
    for (std::map<node, int>::const_iterator i = temp.begin(); i != temp.end(); ++i) {
      result[ nodeToName[ i->first ] ] = i->second;
    }
    return result;
  }

  node createNode(long aName, double aWeight) {
    return node(aName, aWeight);
  }
  node createNode(std::string aName, double aWeight) {
    return node(string_map, aName, aWeight);
  }
  edge createEdge(node aSrc, node aDst, double aWeight) {
    return edge(aSrc, aDst, aWeight);
  }
  void refine(std::map<node, int> nodeToCluster, std::map< node, std::list<edge> > nodeToEdges, double atedges, double atpairs);
  std::map<node, int> cluster(std::list<node>& nodes, std::list<edge>& edges, double atedges, double atpairs);
  std::map<node, int> execute(std::list<node>& nodes, std::list<edge>& edges, bool ignoreLoops);

};

double
edge_density(class edge& edge) {
  return edge.weight / (edge.src.weight * edge.dst.weight);
}

double qualityFunc(double interAtedges, double interAtpairs, double atedges, double atpairs) {
  return interAtedges/atedges - interAtpairs/atpairs;
}

void
NewmanGirvan::refine(std::map<node, int> nodeToCluster, std::map< node, std::list<edge> > nodeToEdges, double atedges, double atpairs) {
  int maxCluster = 0;

  for (std::map< node, int >::const_iterator i = nodeToCluster.begin(); i != nodeToCluster.end(); ++i) {
    maxCluster = std::max(maxCluster, i->second);
  }

  // compute clusterToAtnodes, interAtedges, interAtpairs
  std::vector<double> clusterToAtnodes( nodeToCluster.size() + 1 );

  for (std::map< node, int >::const_iterator i = nodeToCluster.begin(); i != nodeToCluster.end(); ++i) {
    clusterToAtnodes[nodeToCluster[i->first]] += i->first.weight;
  }

  double interAtedges = 0.0;
  for (std::map< node, std::list<edge> >::const_iterator i = nodeToEdges.begin(); i != nodeToEdges.end(); ++i) {
    for (std::list<edge>::const_iterator i2 = i->second.begin(); i2 != i->second.end(); ++i2) {
      if ( !nodeToCluster[i2->src] == nodeToCluster[i2->dst] ) {
        interAtedges += i2->weight;
      }
    }
  }
  double interAtpairs = 0.0;

  for (std::map< node, int >::const_iterator i = nodeToCluster.begin(); i != nodeToCluster.end(); ++i) {
    interAtpairs += i->first.weight;
  }

  interAtpairs *= interAtpairs; 

  for (std::vector<double>::const_iterator i = clusterToAtnodes.begin(); i != clusterToAtnodes.end(); ++i) {
    interAtpairs -= *i * *i;
  }

  // greedily move nodes between clusters 
  double prevQuality = std::numeric_limits<double>::max(); 
  double quality = qualityFunc(interAtedges, interAtpairs, atedges, atpairs);

  while (quality < prevQuality) {
    prevQuality = quality;
    for (std::map< node, int >::const_iterator i = nodeToCluster.begin(); i != nodeToCluster.end(); ++i) {
      node node = i->first;
      int bestCluster = 0; 
      double bestQuality = quality, bestInterAtedges = interAtedges, bestInterAtpairs = interAtpairs;
      std::vector<double> clusterToAtedges(nodeToCluster.size() + 1);

      for (std::list<edge>::const_iterator i = nodeToEdges[node].begin(); i != nodeToEdges[node].end(); ++i) {
        if (!(i->dst == node)) {
          // count weight twice to include reverse edge
          clusterToAtedges[nodeToCluster[i->dst]] += 2 * i->weight;
        }
      }
      int cluster = nodeToCluster[node];
      for (int newCluster = 0; newCluster <= maxCluster+1; newCluster++) {
        if (cluster == newCluster) continue;
        double newInterPairs = interAtpairs
          + clusterToAtnodes[cluster] * clusterToAtnodes[cluster]
          - (clusterToAtnodes[cluster]-node.weight) * (clusterToAtnodes[cluster]-node.weight)
          + clusterToAtnodes[newCluster] * clusterToAtnodes[newCluster]
          - (clusterToAtnodes[newCluster]+node.weight) * (clusterToAtnodes[newCluster]+node.weight);
        double newInterEdges = interAtedges 
          + clusterToAtedges[cluster]
        - clusterToAtedges[newCluster];
        double newQuality = qualityFunc(newInterEdges, newInterPairs, atedges, atpairs); 
        if (bestQuality - newQuality > 1e-8) {
          bestCluster = newCluster;
          bestQuality = newQuality;
          bestInterAtedges = newInterEdges;
          bestInterAtpairs = newInterPairs;
        }
      }
      if (bestQuality < quality) {
        clusterToAtnodes[cluster] -= node.weight;
        clusterToAtnodes[bestCluster] += node.weight;
        nodeToCluster[node] = bestCluster;
        maxCluster = std::max(maxCluster, bestCluster);
        quality = bestQuality;
        interAtedges = bestInterAtedges;
        interAtpairs = bestInterAtpairs;
      }
    }
  }
}

bool
compare_density(edge& first, edge& second) {
  return edge_density(first) > edge_density(second);
}

std::map<node, int>
NewmanGirvan::cluster(std::list<node>& nodes, std::list<edge>& edges, double atedges, double atpairs) {
    edges.sort(compare_density);

    std::map<node, node> nodeToContr;
    std::list<node> contrNodes;

    for (std::list<edge>::const_iterator i = edges.begin(); i != edges.end(); ++i) {
      edge edge = *i;
      if (edge_density(edge) < atedges/atpairs) break;
      if (edge.src == edge.dst) continue;
      if (nodeToContr.find(edge.src) != nodeToContr.end() || nodeToContr.find(edge.dst) != nodeToContr.end()) continue;
      // randomize contraction
      // if (!nodeToContr.isEmpty() && Math.random() < 0.5) continue;

      std::stringstream ss;
      ss << edge.src.name << " " << edge.dst.name;

      node contrNode = createNode(ss.str(), edge.src.weight + edge.dst.weight);

      nodeToContr.insert(std::pair<node,node>(edge.src, contrNode));
      nodeToContr.insert(std::pair<node,node>(edge.dst, contrNode));
      contrNodes.push_back(contrNode);
    }
    // terminal case: no nodes to contract
    if (nodeToContr.empty()) {
      std::map<node, int> nodeToCluster;
      int clusterId = 0;
      for (std::list<node>::const_iterator i = nodes.begin(); i != nodes.end(); ++i) {
        nodeToCluster.insert(std::pair<node, int>(*i, clusterId++));
      }
      return nodeToCluster;
    }

    // "contract" singleton clusters
    for (std::list<node>::const_iterator i = nodes.begin(); i != nodes.end(); ++i) {
      class node node = *i;
      if (nodeToContr.find(node) == nodeToContr.end()) {
        class node contrNode = createNode(node.name, node.weight);
        nodeToContr.insert(std::pair<class node, class node>(node, contrNode));
        contrNodes.push_back(contrNode);
      }
    }

    // contract edges
    std::map< node, std::map< node, double > > startToEndToWeight;
    std::map< node, std::map< node, double > >::const_iterator stetw_iter;

    for (std::list<node>::const_iterator i = contrNodes.begin(); i != contrNodes.end(); ++i) {
      startToEndToWeight.insert(std::pair<node, std::map<node, double> >(*i, std::map<node, double>()));
    }
    for (std::list<edge>::const_iterator i = edges.begin(); i != edges.end(); ++i) {
      class edge edge = *i;
      node contrStart = nodeToContr[edge.src];
      node contrEnd   = nodeToContr[edge.dst];
      double contrWeight = 0.0;
      std::map<node, double>& endToWeight = startToEndToWeight[contrStart];
      if (endToWeight.find(contrEnd) != endToWeight.end()) {
        contrWeight = endToWeight[contrEnd];
      }
      endToWeight[contrEnd] = contrWeight + edge.weight;
    }

    std::list<edge> contrEdges;
    for (stetw_iter = startToEndToWeight.begin(); stetw_iter != startToEndToWeight.end(); ++stetw_iter) {
      class node contrStart = stetw_iter->first;
      std::map<node, double>& endToWeight = startToEndToWeight[contrStart];
      for (std::map<node, double>::const_iterator i2 = endToWeight.begin(); i2 != endToWeight.end(); ++i2) {
        class node contrEnd = i2->first;
        class edge contrEdge = createEdge(contrStart, contrEnd, endToWeight[contrEnd]);
        contrEdges.push_back(contrEdge);
      }
    }

    // cluster contracted graph
    std::map<node, int> contrNodeToCluster 
      = cluster(contrNodes, contrEdges, atedges, atpairs);

    // decontract clustering
    std::map<node, int> nodeToCluster;
    for (std::map<node, node>::const_iterator i = nodeToContr.begin(); i != nodeToContr.end(); ++i) {
      nodeToCluster.insert(std::pair<node, int>(i->first, contrNodeToCluster[nodeToContr[i->first]]));
    }

    // refine decontracted clustering
    std::map< node, std::list<edge> > nodeToEdge;

    for (std::list<node>::const_iterator i = nodes.begin(); i != nodes.end(); ++i) {
      nodeToEdge.insert(std::pair<node, std::list<edge> >(*i, std::list<edge>()));
    }
    for (std::list<edge>::const_iterator i = edges.begin(); i != edges.end(); ++i) {
      nodeToEdge[i->src].push_back(*i);
    }

    refine(nodeToCluster, nodeToEdge, atedges, atpairs);

    return nodeToCluster;
}

std::map<node, int>
NewmanGirvan::execute(std::list<node>& nodes, std::list<edge>& edges, bool ignoreLoops) {

  // compute atedgeCnt and atpairCnt
  double atedgeCnt = 0.0; 
  for (std::list<edge>::const_iterator i = edges.begin(); i != edges.end(); ++i) {
    if (!ignoreLoops || !(i->src == i->dst)) { 
      atedgeCnt += i->weight;
    }
  }

  double atpairCnt = 0.0; 
  for (std::list<node>::const_iterator i = nodes.begin(); i != nodes.end(); ++i) {
    atpairCnt += i->weight;
  }
  atpairCnt *= atpairCnt;
  if (ignoreLoops) { 
    for (std::list<node>::const_iterator i = nodes.begin(); i != nodes.end(); ++i) {
      atpairCnt -= i->weight * i->weight;
    }
  }
        
  // compute clustering
  return cluster(nodes, edges, atedgeCnt, atpairCnt);
}



#line 384 "NewmanGirvan.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 528 "NewmanGirvan.c"

XS_EUPXS(XS_Graph__NewmanGirvan_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__NewmanGirvan_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "CLASS");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0))
;
	NewmanGirvan *	RETVAL;

	RETVAL = new NewmanGirvan();
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, CLASS, (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Graph__NewmanGirvan_add_edge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__NewmanGirvan_add_edge)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "THIS, src, dst, weight");
    {
	NewmanGirvan *	THIS;
	const char*	src = (const char *)SvPV_nolen(ST(1))
;
	const char*	dst = (const char *)SvPV_nolen(ST(2))
;
	double	weight = (double)SvNV(ST(3))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NewmanGirvan *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Graph::NewmanGirvan::add_edge() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->add_edge(src, dst, weight);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Graph__NewmanGirvan_set_vertex_weight); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__NewmanGirvan_set_vertex_weight)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "THIS, vertex, weight");
    {
	NewmanGirvan *	THIS;
	const char*	vertex = (const char *)SvPV_nolen(ST(1))
;
	double	weight = (double)SvNV(ST(2))
;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NewmanGirvan *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Graph::NewmanGirvan::set_vertex_weight() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	THIS->set_vertex_weight(vertex, weight);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Graph__NewmanGirvan_compute); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__NewmanGirvan_compute)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 388 "NewmanGirvan.xs"
#line 619 "NewmanGirvan.c"
	NewmanGirvan *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NewmanGirvan *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Graph::NewmanGirvan::compute() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;
#line 389 "NewmanGirvan.xs"
    std::map<std::string, int> result = THIS->run();
    for (std::map<std::string, int>::const_iterator i = result.begin(); i != result.end(); ++i) {
      mXPUSHs(newSVpvn(i->first.c_str(), i->first.size()));
      mXPUSHs(newSVnv(i->second));
    }
#line 635 "NewmanGirvan.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Graph__NewmanGirvan_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__NewmanGirvan_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "THIS");
    {
	NewmanGirvan *	THIS;

	if( sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG) )
		THIS = (NewmanGirvan *)SvIV((SV*)SvRV( ST(0) ));
	else{
		warn( "Graph::NewmanGirvan::DESTROY() -- THIS is not a blessed SV reference" );
		XSRETURN_UNDEF;
	}
;

	delete THIS;
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Graph__NewmanGirvan); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Graph__NewmanGirvan)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Graph::NewmanGirvan::new", XS_Graph__NewmanGirvan_new);
        newXS_deffile("Graph::NewmanGirvan::add_edge", XS_Graph__NewmanGirvan_add_edge);
        newXS_deffile("Graph::NewmanGirvan::set_vertex_weight", XS_Graph__NewmanGirvan_set_vertex_weight);
        newXS_deffile("Graph::NewmanGirvan::compute", XS_Graph__NewmanGirvan_compute);
        newXS_deffile("Graph::NewmanGirvan::DESTROY", XS_Graph__NewmanGirvan_DESTROY);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
